<template>
  <v-row>
    <v-col :cols="cols" class="pa-1">
      <NodeDatePicker
        :value.sync="start"
        :label="label"
        min="0000-01-01"
        :error.sync="errorMsg"
      />
      <v-row v-if="errorMsg">
        <v-col class="pt-5 pl-6">
          <p class="custom-label error--text">
            {{ errorMsg }}
          </p>
        </v-col>
      </v-row>
    </v-col>
  </v-row>
</template>
<script>
import NodeDatePicker from '@/components/NodeDatePicker.vue'
import edtf from 'edtf'

export default {
  name: 'DateIntervalPicker',
  props: {
    interval: String,
    label: {
      type: String,
      required: true
    },
    cols: {
      type: String,
      default: '12'
    },
    field: Object,
    submitted: Boolean
  },
  components: {
    NodeDatePicker
  },
  data () {
    return {
      start: '',
      errorMsg: null
    }
  },
  watch: {
    interval: {
      deep: true,
      immediate: true,
      handler (interval) {
        if (!interval) interval = '/'
        if (interval === null || interval === '') interval = '/'
        const [start, end] = interval.split('/')
        this.start = start
        this.end = end
      }
    },
    start () {
      this.updateInterval()
    },
    isRequired (newVal) {
      if (newVal) this.errorMsg = 'date is required'
      else this.errorMsg = null
    }
  },
  computed: {
    customProps () {
      return {
        hideDetails: true,
        placeholder: ' ',
        class: 'mt-0',
        light: true
      }
    },
    isRequired () {
      return this.submitted && this.field.required && !this.start
    }
  },
  methods: {
    updateInterval () {
      let interval = this.start + '/' + this.end

      try {
        if (this.start === '' && this.end !== '') {
          const [year] = this.end.split('-')
          interval = year + '/' + this.end
        } else if (this.start !== this.end) edtf(interval)
        this.$emit('update:interval', interval)
        this.errorMsg = null
      } catch (err) {
        this.errorMsg = 'Please try another date range'
      }
    }
  }
}
</script>

<style scoped lang="scss">
.custom.v-text-field > .v-input__control > .v-input__slot:before {
  border-style: none;
}
.custom.v-text-field > .v-input__control > .v-input__slot:after {
  border-style: none;
}
.custom-label {
  font-size: 12px;
  margin-left: 8px;
  color: var(--custom-label);
  padding-left: 3px;
  padding-right: 3px;
}
</style>
